import rwmap._frame as frame
from typing import Union

class KEY:
    empty_tile = "0"
    empty_tile_for_tilegroup = "e"
    tag_for_tile_notre = "|"

class NAME:
    Ground = "Ground"
    PathingOverride = "PathingOverride"
    Units = "Units"
    ItemsExtra = "ItemsExtra"
    Items = "Items"
    GroundDetails = "GroundDetails"
    Triggers = "Triggers"

class OBJECTTYPE:
    team_info = "team_info"
    unitAdd = "unitAdd"
    unitRemove = "unitRemove"
    unitDetect = "unitDetect"
    mapText = "mapText"
    camera_pan = "camera_pan"
    objective = "objective"
    basic = "basic"
    fall = "fall"
    rotate = "rotate"
    move = "move"
    point = "point"
    set_team = "set_team"
    ai_allow_full_use = "ai_allow_full_use"
    disable_unit_ai = "disable_unit_ai"
    moveCamera = "moveCamera"
    changeCredits = "changeCredits"
    teamTags = "teamTags"
    teamTagDetect = "teamTagDetect"

class OBJECTDE:
    x = "x" 
    y = "y"
    width = "width"
    height = "height"
    type = "type"
    id = "id"
    name = "name"

class OBJECTOP:
    credits = "credits"
    disabledAI = "disabledAI"
    lockAiDifficulty = "lockAiDifficulty"
    ai = "ai"
    allyGroup = "allyGroup"
    basicAI = "basicAI"
    unitType = "unitType"
    onlyIdle = "onlyIdle"
    onlyBuildings = "onlyBuildings"
    onlyMainBuildings = "onlyMainBuildings"
    onlyEmptyQueue = "onlyEmptyQueue"
    onlyBuilders = "onlyBuilders"
    onlyOnResourcePool = "onlyOnResourcePool"
    onlyAttack = "onlyAttack"
    onlyAttackAir = "onlyAttackAir"
    onlyTechLevel = "onlyTechLevel"
    includeIncomplete = "includeIncomplete"
    minUnits = "minUnits"
    maxUnits = "maxUnits"
    onlyWithTag = "onlyWithTag"
    target = "target"
    unload = "unload"
    dir = "dir"
    addTeamTags = "addTeamTags"
    removeTeamTags = "removeTeamTags"
    teamTag = "teamTag"
    text = "text"
    textColor = "textColor"
    textSize = "textSize"
    textOffsetX = "textOffsetX"
    textOffsetY = "textOffsetY"
    style = "style"
    text_lang = "text_lang"
    set = "set"
    add = "add"
    spawnUnits = "spawnUnits"
    neutralTeam = "neutralTeam"
    spawnChance = "spawnChance"
    maxSpawnLimit = "maxSpawnLimit"
    techLevel = "techLevel"
    gridAlign = "gridAlign"
    skipIfOverlapping = "skipIfOverlapping"
    falling = "falling"
    offsetX = "offsetX"
    offsetY = "offsetY"
    offsetRandomX = "offsetRandomX"
    offsetRandomY = "offsetRandomY"
    offsetRandomXY = "offsetRandomXY"
    offsetHeight = "offsetHeight"
    offsetDir = "offsetDir"
    offsetRandomDir = "offsetRandomDir"
    team = "team"
    globalMessage = "globalMessage"
    globalMessage_delayPerChar = "globalMessage_delayPerChar"
    globalMessage_textColor = "globalMessage_textColor"
    debugMessage = "debugMessage"
    warmup = "warmup"
    delay = "delay"
    resetActivationAfter = "resetActivationAfter"
    repeatDelay = "repeatDelay"
    alsoActivate = "alsoActivate"
    id = "id"
    activatedBy = "activatedBy"
    deactivatedBy = "deactivatedBy"
    allToActivate = "allToActivate"
    activateIds = "activateIds"
    whenActivatedIds = "whenActivatedIds"
    showOnMap = "showOnMap"

class MAPTYPE:
    skirmish = "skirmish"
    challenge = "challenge"
    survival = "survival"
    mission = "mission"

class FOG:
    NONE = "NONE"
    map = "map"
    los = "los"

class WIN:
    NONE = "NONE"
    mainBuildings = "mainBuildings"
    allUnitsAndBuildings = "allUnitsAndBuildings"
    allBuildings = "allBuildings"
    commandCenter = "commandCenter"
    requiredObjectives = "requiredObjectives"

class COO:
    SIZE_STANDARD = frame.Coordinate(20, 20)

class TYPE:
    tileid = Union[int, tuple[str, int], frame.TagCoordinate]

class UNIT:
    turret_flamethrower = "turret_flamethrower"
    turret_artillery = "turret_artillery"
    turretT2 = "turretT2"
    turret = "turret"
    supplyDepot = "supplyDepot"
    repairbay = "repairbay"
    outpostT1 = "outpostT1"
    outpostT2 = "outpostT2"
    antiAirTurret = "antiAirTurrets"
    builder = "builder"
    landFactory = "landFactory"
    mechGun = "mechGun"
    mechMissile = "mechMissile"
    mechBunker = "mechBunker"
    mechBunkerDeployed = "mechBunkerDeployed"
    heavyArtillery = "heavyArtillery"
    bugMeleeLarge = "bugMeleeLarge"
    hovercraft = "hovercraft"
    antiAirTurret = "antiAirTurret"
    c_antiAirTurretT2 = "c_antiAirTurretT2"
    c_antiAirTurretT3 = "c_antiAirTurretT3"
    combatEngineer = "combatEngineer"
    mechEngineer = "mechEngineer"





